## mingw-w64-inkscape-1.4-6.src.tar.zst

=== CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
cmake_minimum_required(VERSION 3.1.0)

cmake_policy(SET CMP0003 NEW) # don't be prolific with library paths
cmake_policy(SET CMP0005 NEW) # proper define quoting
cmake_policy(SET CMP0009 NEW) # don't follow symbolic links when using GLOB

if(POLICY CMP0075)
    cmake_policy(SET CMP0075 NEW) # link check-executable to CMAKE_REQUIRED_LIBRARIES (CMake 3.12.1)
endif(POLICY CMP0075)

message("------------------------------")
message("Building Makefile for Inkscape")
message("------------------------------")
message("Source Dir: ${CMAKE_CURRENT_SOURCE_DIR}")
message("Binary Dir: ${CMAKE_CURRENT_BINARY_DIR}")

# -----------------------------------------------------------------------------
# CMake Configuration
# -----------------------------------------------------------------------------
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
# set(CMAKE_CXX_EXTENSIONS OFF) # enforces -std=c++20 instead of -std=gnu++20
                                # TODO: build currently fails with it as we actually depend on GNU compiler extensions...
                                #       mostly use of the non-Standard M_PI et al. TODO: C++20: Use the <numbers> header.

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMakeScripts/Modules")

# avoid having empty buildtype
set(CMAKE_BUILD_TYPE_INIT "Release")

include(CMakeScripts/HelperFunctions.cmake)
include(CMakeScripts/ConfigEnv.cmake)

project(inkscape)
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME inkscape) # needs to be before any install() commands

include(GNUInstallDirs) # for the CMAKE_INSTALL_LIBDIR variable
include(CMakeScripts/ConfigPaths.cmake)
include(CMakeDependentOption)

set(PROJECT_NAME inkscape)

# see https://gitlab.com/inkscape/inkscape/-/issues/551 for versioning suffixes
set(INKSCAPE_VERSION_MAJOR  1)
set(INKSCAPE_VERSION_MINOR  4)
set(INKSCAPE_VERSION_PATCH  0)
set(INKSCAPE_VERSION_SUFFIX "")

set(INKSCAPE_VERSION ${INKSCAPE_VERSION_MAJOR}.${INKSCAPE_VERSION_MINOR})
if(INKSCAPE_VERSION_PATCH)
    set(INKSCAPE_VERSION ${INKSCAPE_VERSION}.${INKSCAPE_VERSION_PATCH})
endif()
if(INKSCAPE_VERSION_SUFFIX)
    set(INKSCAPE_VERSION ${INKSCAPE_VERSION}${INKSCAPE_VERSION_SUFFIX})
endif()

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

file(RELATIVE_PATH
    INKSCAPE_INSTALL_LIBDIR_RELATIVE_TO_BINDIR
    "${CMAKE_INSTALL_FULL_BINDIR}"
    "${CMAKE_INSTALL_FULL_LIBDIR}/inkscape")

if(APPLE)
    SET(CMAKE_MACOSX_RPATH TRUE)
    SET(CMAKE_INSTALL_RPATH "@loader_path/${INKSCAPE_INSTALL_LIBDIR_RELATIVE_TO_BINDIR}")
else()
    SET(CMAKE_INSTALL_RPATH "$ORIGIN/${INKSCAPE_INSTALL_LIBDIR_RELATIVE_TO_BINDIR}")
endif()

# this can be removed if/when cmake 3.1 is made the minimum required version
set(PKG_CONFIG_USE_CMAKE_PREFIX_PATH ON)

# console output is slow as hell on Windows and as a result status messages of the "install" target slow down
# the whole build process considerably (especially since we also copy a lot of files from the devlibs)
# TODO: Is this worth to be configurable / also applicable to other platforms?
if(WIN32 AND NOT CMAKE_INSTALL_MESSAGE)
    set(CMAKE_INSTALL_MESSAGE "LAZY")
endif()

# Define a very strict set of build flags that will prevent any use of deprecated symbols.
# This will almost certainly cause compilation failure and is intended only for developer use.
set(CMAKE_CXX_FLAGS_STRICT "${CMAKE_CXX_FLAGS_DEBUG} -Werror=deprecated-declarations -DGTK_DISABLE_DEPRECATED -DGDK_DISABLE_DEPRECATED -DGTKMM_DISABLE_DEPRECATED -DGDKMM_DISABLE_DEPRECATED -DGLIBMM_DISABLE_DEPRECATED"
    CACHE STRING
    "Flags used by C++ compiler during Strict builds"
    FORCE)
set(CMAKE_C_FLAGS_STRICT   "${CMAKE_C_FLAGS_DEBUG}   -Werror=deprecated-declarations -DGTK_DISABLE_DEPRECATED -DGDK_DISABLE_DEPRECATED -DGTKMM_DISABLE_DEPRECATED -DGDKMM_DISABLE_DEPRECATED"
    CACHE STRING
    "Flags used by C compiler during Strict builds"
    FORCE)
mark_as_advanced(
    CMAKE_CXX_FLAGS_STRICT
    CMAKE_C_FLAGS_STRICT)

set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING
    "Choose the type of build, options are: None(CMAKE_CXXFLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel Strict."
    FORCE)

# -----------------------------------------------------------------------------
# Redirect output files
# -----------------------------------------------------------------------------
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR} CACHE PATH "Output directory for runtime binaries")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR} CACHE PATH "Output directory for shared libraries")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR} CACHE PATH "Output directory for static libraries")

# -----------------------------------------------------------------------------
# Options
# -----------------------------------------------------------------------------
option(WITH_GNU_READLINE "Compile with GNU Readline support (shell mode)" ON)
option(ENABLE_LCMS "Compile with LCMS support" ON)
option(WITH_SVG2 "Compile with support for new SVG2 features" ON)
option(WITH_LPETOOL "Compile with LPE Tool" OFF)
option(LPE_ENABLE_TEST_EFFECTS "Compile with test experimental LPEs enabled" OFF)
option(WITH_OPENMP "Compile with OpenMP support" ON)
option(WITH_PROFILING "Turn on profiling" OFF) # Set to true if compiler/linker should enable profiling
option(BUILD_SHARED_LIBS "Compile libraries as shared and not static" ON)

option(ENABLE_POPPLER "Compile with support of libpoppler" ON)
option(ENABLE_POPPLER_CAIRO "Compile with support of libpoppler-cairo for rendering PDF preview (depends on ENABLE_POPPLER)" ON)
option(WITH_IMAGE_MAGICK "Compile with support of ImageMagick for raster extensions and image import resolution (requires ImageMagick 6; set to OFF if you prefer GraphicsMagick)" ON)
option(WITH_GRAPHICS_MAGICK "Compile with support of GraphicsMagick for raster extensions and image import resolution" ON)
option(WITH_LIBCDR "Compile with support of libcdr for CorelDRAW Diagrams" ON)
option(WITH_LIBVISIO "Compile with support of libvisio for Microsoft Visio Diagrams" ON)
option(WITH_LIBWPG "Compile with support of libwpg for WordPerfect Graphics" ON)
option(WITH_GSPELL "Compile with support of gspell" ON)
option(WITH_GSOURCEVIEW "Compile with support of gsourceview (text syntax coloring)" ON)
option(WITH_NLS "Compile with Native Language Support (using gettext)" ON)
option(WITH_JEMALLOC "Compile with JEMALLOC support" OFF)
option(WITH_ASAN "Compile with Clang's AddressSanitizer (for debugging purposes)" OFF)
option(WITH_INTERNAL_2GEOM "Prefer internal copy of lib2geom" OFF)
cmake_dependent_option(WITH_X11 "Compile with X11 support" ON "UNIX; NOT APPLE" OFF)

option(WITH_FUZZ "Compile for fuzzing purpose (use 'make fuzz' only)" OFF)
mark_as_advanced(WITH_FUZZ)
option(WITH_MANPAGE_COMPRESSION "gzips manpages if gzip is available" ON)
mark_as_advanced(WITH_MANPAGE_COMPRESSION)

option(ENABLE_BINRELOC "Enable relocatable binaries" OFF)


include(CMakeScripts/DefineDependsandFlags.cmake) # Includes, Compiler Flags, and Link Libraries
include(CMakeScripts/HelperMacros.cmake) # Misc Utility Macros

# -----------------------------------------------------------------------------
# BAD HACKS, NEED TO INVESTIGATE MAKING THESE LESS BAD
if(BUILD_SHARED_LIBS AND NOT WIN32)
    add_definitions(-fPIC)
endif()
#
# end badness
# -----------------------------------------------------------------------------



# -----------------------------------------------------------------------------
# Subdirectories
# -----------------------------------------------------------------------------
add_subdirectory(src)

if(ENABLE_NLS)
    add_subdirectory(po)
endif(ENABLE_NLS)

if(NOT WIN32)
    include(CMakeScripts/Pod2man.cmake)
    add_subdirectory(man)
endif()



# -----------------------------------------------------------------------------
# Check License Headers
# -----------------------------------------------------------------------------
add_custom_target(check-license-headers WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} COMMAND ./buildtools/check_license_headers.py)


# -----------------------------------------------------------------------------
# Test Harness
# -----------------------------------------------------------------------------

if(BUILD_TESTING OR NOT DEFINED BUILD_TESTING)
    find_package(GTest)
    if(GTEST_FOUND)
        set(DART_TESTING_TIMEOUT 180 CACHE STRING "Test timeout") # if running for > 180 s something must be wrong)
        include(CTest)
        add_subdirectory(testfiles EXCLUDE_FROM_ALL)
    else()
        set(BUILD_TESTING OFF)
        message(WARNING "No gtest found! Disabling testing...\n"
                        "Consider installing it via package manager (install 'libgtest-dev' or equivalent).")
    endif()
endif()


# -----------------------------------------------------------------------------
# Clean Targets
# -----------------------------------------------------------------------------
add_custom_target(clean-cmake-files
    COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/CMakeScripts/CleanAll.cmake"
)

add_custom_target(clean-all
    COMMAND ${CMAKE_BUILD_TOOL} clean
    COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/CMakeScripts/CleanAll.cmake"
)

# -----------------------------------------------------------------------------
# Install Target
# -----------------------------------------------------------------------------
add_subdirectory(share)

if(WIN32)
  include(CMakeScripts/InstallMSYS2.cmake)
endif()

# -----------------------------------------------------------------------------
# Uninstall Target
# -----------------------------------------------------------------------------
if(WIN32)
    add_custom_target(uninstall
        "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_INSTALL_PREFIX}")
else()
    configure_file(
        "${CMAKE_SOURCE_DIR}/CMakeScripts/cmake_uninstall.cmake.in"
        "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake"
        @ONLY)
    add_custom_target(uninstall
        "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

# -----------------------------------------------------------------------------
# Dist Targets
# -----------------------------------------------------------------------------
include(CMakeScripts/Dist.cmake)

# -----------------------------------------------------------------------------
# Packaging (CPack)
# -----------------------------------------------------------------------------
include(CMakeScripts/ConfigCPack.cmake)



# ----------------------------------------------------------------------
# Information Summary
# ----------------------------------------------------------------------
message("------------------------------------------------------------------------")
message("Configuration Summary")
message("------------------------------------------------------------------------")
# project info
message("PROJECT_NAME:            ${PROJECT_NAME}")
message("INKSCAPE_VERSION:        ${INKSCAPE_VERSION}")
message("INKSCAPE_DIST_PREFIX:    ${INKSCAPE_DIST_PREFIX}")
message("")

# cmake info
message("CMAKE_BINARY_DIR:        ${CMAKE_BINARY_DIR}")
message("CMAKE_INSTALL_PREFIX:    ${CMAKE_INSTALL_PREFIX}")
message("CMAKE_INSTALL_LIBDIR:    ${CMAKE_INSTALL_LIBDIR}")
message("PACKAGE_LOCALE_DIR       ${PACKAGE_LOCALE_DIR}")
message("CMAKE_SYSTEM_NAME:       ${CMAKE_SYSTEM_NAME}")
message("CMAKE_SYSTEM_VERSION:    ${CMAKE_SYSTEM_VERSION}")
message("CMAKE_SYSTEM_PROCESSOR:  ${CMAKE_SYSTEM_PROCESSOR}")
message("CMAKE_C_COMPILER:        ${CMAKE_C_COMPILER}")
message("CMAKE_CXX_COMPILER:      ${CMAKE_CXX_COMPILER}")
message("CMAKE_BUILD_TYPE:        ${CMAKE_BUILD_TYPE}")
message("")

if(WIN32)
message("CMAKE_PREFIX_PATH:           ${CMAKE_PREFIX_PATH}")
message("CMAKE_FIND_LIBRARY_PREFIXES: ${CMAKE_FIND_LIBRARY_PREFIXES}")
message("CMAKE_FIND_LIBRARY_SUFFIXES: ${CMAKE_FIND_LIBRARY_SUFFIXES}")
message("")
endif()

=== src/ui/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
set(ui_SRC
	builder-utils.cpp
	clipboard.cpp
	contextmenu.cpp
	controller.cpp
	cursor-utils.cpp
	dialog-events.cpp
	dialog-run.cpp
	draw-anchor.cpp
	drag-and-drop.cpp
	icon-loader.cpp
	interface.cpp
	menuize.cpp
	monitor.cpp
	pack.cpp
	popup-menu.cpp
	selected-color.cpp
	shape-editor.cpp
	shape-editor-knotholders.cpp
	simple-pref-pusher.cpp
	shortcuts.cpp
	svg-renderer.cpp
	syntax.cpp
	themes.cpp
	tool-factory.cpp
	util.cpp
	modifiers.cpp

	cache/svg_preview_cache.cpp

	desktop/document-check.cpp
	desktop/menubar.cpp
	desktop/menu-set-tooltips-shift-icons.cpp

	knot/knot.cpp
	knot/knot-holder.cpp
	knot/knot-holder-entity.cpp
	knot/knot-ptr.cpp

	tool/control-point-selection.cpp
	tool/control-point.cpp
	tool/curve-drag-point.cpp
	tool/modifier-tracker.cpp
	tool/multi-path-manipulator.cpp
	tool/node.cpp
	tool/path-manipulator.cpp
	tool/selectable-control-point.cpp
	tool/transform-handle-set.cpp

	toolbar/arc-toolbar.cpp
	toolbar/box3d-toolbar.cpp
	toolbar/calligraphy-toolbar.cpp
	toolbar/connector-toolbar.cpp
	toolbar/dropper-toolbar.cpp
	toolbar/marker-toolbar.cpp
	toolbar/eraser-toolbar.cpp
	toolbar/gradient-toolbar.cpp
	toolbar/lpe-toolbar.cpp
	toolbar/measure-toolbar.cpp
	toolbar/mesh-toolbar.cpp
	toolbar/node-toolbar.cpp
	toolbar/page-toolbar.cpp
	toolbar/paintbucket-toolbar.cpp
	toolbar/pencil-toolbar.cpp
	toolbar/rect-toolbar.cpp
	toolbar/select-toolbar.cpp
	toolbar/booleans-toolbar.cpp
	toolbar/spiral-toolbar.cpp
	toolbar/spray-toolbar.cpp
	toolbar/star-toolbar.cpp
	toolbar/text-toolbar.cpp
	toolbar/toolbar.cpp
	toolbar/tweak-toolbar.cpp
	toolbar/zoom-toolbar.cpp

	toolbar/command-toolbar.cpp
	toolbar/tool-toolbar.cpp
	toolbar/snap-toolbar.cpp
	toolbar/toolbars.cpp

	tools/arc-tool.cpp
	tools/box3d-tool.cpp
	tools/calligraphic-tool.cpp
	tools/connector-tool.cpp
	tools/dropper-tool.cpp
	tools/dynamic-base.cpp
	tools/eraser-tool.cpp
	tools/flood-tool.cpp
	tools/freehand-base.cpp
	tools/gradient-tool.cpp
	tools/lpe-tool.cpp
	tools/measure-tool.cpp
	tools/mesh-tool.cpp
	tools/node-tool.cpp
	tools/object-picker-tool.cpp
	tools/pages-tool.cpp
	tools/pencil-tool.cpp
	tools/pen-tool.cpp
	tools/rect-tool.cpp
	tools/marker-tool.cpp
	tools/select-tool.cpp
	tools/booleans-builder.cpp
	tools/booleans-tool.cpp
	tools/booleans-subitems.cpp
	tools/shortcuts.cpp
	tools/spiral-tool.cpp
	tools/spray-tool.cpp
	tools/star-tool.cpp
	tools/text-tool.cpp
	tools/tool-base.cpp
	tools/tweak-tool.cpp
	tools/zoom-tool.cpp

	dialog/about.cpp
	dialog/align-and-distribute.cpp
	dialog/calligraphic-profile-rename.cpp
	dialog/clonetiler.cpp
	dialog/color-item.cpp
	dialog/command-palette.cpp
	dialog/attrdialog.cpp
	dialog/dialog-base.cpp
	dialog/dialog-container.cpp
	dialog/dialog-data.cpp
	dialog/dialog-manager.cpp
	dialog/dialog-multipaned.cpp
	dialog/dialog-notebook.cpp
	dialog/dialog-window.cpp
	dialog/document-properties.cpp
	dialog/document-resources.cpp
	dialog/export.cpp
	dialog/export-batch.cpp
	dialog/export-single.cpp
	dialog/extensions-gallery.cpp
	dialog/filedialog.cpp
	dialog/filedialogimpl-gtkmm.cpp
	dialog/fill-and-stroke.cpp
	dialog/filter-effects-dialog.cpp
	dialog/find.cpp
	dialog/font-collections-manager.cpp
	widget/font-collection-selector.cpp
	dialog/font-substitution.cpp
	dialog/global-palettes.cpp
	dialog/glyphs.cpp
	dialog/grid-arrange-tab.cpp
	dialog/guides.cpp
	dialog/icon-preview.cpp
	dialog/inkscape-preferences.cpp
	dialog/knot-properties.cpp
	dialog/layer-properties.cpp
	dialog/livepatheffect-editor.cpp
	dialog/lpe-fillet-chamfer-properties.cpp
	dialog/lpe-powerstroke-properties.cpp
	dialog/memory.cpp
	dialog/messages.cpp
	dialog/new-from-template.cpp
	dialog/object-attributes.cpp
	dialog/object-properties.cpp
	dialog/objects.cpp
	dialog/polar-arrange-tab.cpp
	dialog/print.cpp
	dialog/prototype.cpp
	dialog/selectorsdialog.cpp
	dialog/startup.cpp
	dialog/styledialog.cpp
	dialog/svg-fonts-dialog.cpp
	dialog/svg-preview.cpp
	dialog/swatches.cpp
	dialog/symbols.cpp
	dialog/paint-servers.cpp
	dialog/text-edit.cpp
	dialog/tile.cpp
	dialog/tracedialog.cpp
	dialog/transformation.cpp
	dialog/undo-history.cpp
	dialog/xml-tree.cpp
	dialog/save-template-dialog.cpp

	widget/iconrenderer.cpp
	widget/alignment-selector.cpp
	widget/anchor-selector.cpp
	widget/completion-popup.cpp
	widget/canvas.cpp
	widget/canvas/stores.cpp
	widget/canvas/synchronizer.cpp
	widget/canvas/util.cpp
	widget/canvas/texture.cpp
	widget/canvas/texturecache.cpp
	widget/canvas/pixelstreamer.cpp
	widget/canvas/updaters.cpp
	widget/canvas/framecheck.cpp
	widget/canvas/glgraphics.cpp
	widget/canvas/cairographics.cpp
	widget/canvas/graphics.cpp
	widget/canvas-grid.cpp
	widget/canvas-notice.cpp
	widget/color-entry.cpp
	widget/color-icc-selector.cpp
	widget/color-notebook.cpp
	widget/color-palette.cpp
	widget/color-palette-preview.cpp
	widget/color-picker.cpp
	widget/color-preview.cpp
	icon-loader.cpp
	widget/color-scales.cpp
	widget/color-slider.cpp
	widget/combo-box-entry-tool-item.cpp
	widget/combo-tool-item.cpp
	widget/css-name-class-init.cpp
	widget/custom-tooltip.cpp
	widget/dash-selector.cpp
        widget/desktop-widget.cpp
	widget/entity-entry.cpp
	widget/entry.cpp
	widget/export-lists.cpp
	widget/export-preview.cpp
	widget/filter-effect-chooser.cpp
	widget/fill-style.cpp
	widget/font-button.cpp
	widget/font-list.cpp
	widget/font-selector.cpp
	widget/font-selector-toolbar.cpp
	widget/font-variants.cpp
	widget/font-variations.cpp
	widget/frame.cpp
	widget/gradient-image.cpp
	widget/gradient-editor.cpp
	widget/gradient-selector.cpp
	widget/gradient-vector-selector.cpp
	widget/gradient-with-stops.cpp
	widget/image-properties.cpp
	widget/imagetoggler.cpp
	widget/ink-color-wheel.cpp
	widget/ink-ruler.cpp
	widget/ink-spinscale.cpp
	widget/labelled.cpp
	widget/layer-selector.cpp
	widget/licensor.cpp
	widget/marker-combo-box.cpp
	widget/notebook-page.cpp
	widget/object-composite-settings.cpp
	widget/objects-dialog-cells.cpp
	widget/oklab-color-wheel.cpp
	widget/optglarea.cpp
	widget/page-properties.cpp
	widget/page-size-preview.cpp
	widget/page-selector.cpp
	widget/paint-selector.cpp
	widget/pattern-editor.cpp
	widget/point.cpp
	widget/popover-menu.cpp
	widget/popover-menu-item.cpp
	widget/preferences-widget.cpp
	widget/random.cpp
	widget/registered-widget.cpp
	widget/registry.cpp
	widget/rendering-options.cpp
	widget/rotateable.cpp
	widget/scalar-unit.cpp
	widget/scalar.cpp
	widget/scroll-utils.cpp
	widget/selected-style.cpp
	widget/shapeicon.cpp
	widget/spin-scale.cpp
	widget/spinbutton.cpp
        widget/status-bar.cpp
	widget/stroke-style.cpp
	widget/style-subject.cpp
	widget/style-swatch.cpp
	widget/swatch-selector.cpp
	widget/template-list.cpp
	widget/text.cpp
	widget/toolbar-menu-button.cpp
	widget/unit-menu.cpp
	widget/unit-tracker.cpp

	view/svg-view-widget.cpp


	# -------
	# Headers
	builder-utils.h
	clipboard.h
	contextmenu.h
	controller.h
	cursor-utils.h
	control-types.h
	dialog-events.h
	dialog-run.h
	drag-and-drop.h
	draw-anchor.h
	filtered-store.h
	icon-names.h
	icon-loader.h
	interface.h
	manage.h
	menuize.h
	monitor.h
	pack.h
	popup-menu.h
	selected-color.h
	shape-editor.h
	simple-pref-pusher.h
	shortcuts.h
	syntax.h
	themes.h
	tool-factory.h
	util.h
	modifiers.h

	cache/svg_preview_cache.h

	desktop/document-check.h
	desktop/menubar.h
	desktop/menu-set-tooltips-shift-icons.h

	dialog/about.h
	dialog/align-and-distribute.h
	dialog/arrange-tab.h
	dialog/calligraphic-profile-rename.h
	dialog/clonetiler.h
	dialog/color-item.h
	dialog/command-palette.h
	dialog/attrdialog.h
	dialog/dialog-base.h
	dialog/dialog-container.h
	dialog/dialog-data.h
	dialog/dialog-manager.h
	dialog/dialog-multipaned.h
	dialog/dialog-notebook.h
	dialog/dialog-window.h
	dialog/document-properties.h
	dialog/export.h
	dialog/export-batch.h
	dialog/export-single.h
	dialog/extensions-gallery.h
	dialog/filedialog.h
	dialog/filedialogimpl-gtkmm.h
	dialog/filedialogimpl-win32.h
	dialog/fill-and-stroke.h
	dialog/filter-effects-dialog.h
	dialog/find.h
	dialog/font-collections-manager.h
	dialog/font-substitution.h
	dialog/global-palettes.h
	dialog/glyphs.h
	dialog/grid-arrange-tab.h
	dialog/guides.h
	dialog/icon-preview.h
	dialog/inkscape-preferences.h
	dialog/knot-properties.h
	dialog/layer-properties.h
	dialog/livepatheffect-editor.h
	dialog/lpe-fillet-chamfer-properties.h
	dialog/lpe-powerstroke-properties.h
	dialog/memory.h
	dialog/messages.h
	dialog/new-from-template.h
	dialog/object-attributes.h
	dialog/object-properties.h
	dialog/objects.h
	dialog/polar-arrange-tab.h
	dialog/print.h
	dialog/prototype.h
	dialog/selectorsdialog.h
	dialog/startup.h
	dialog/styledialog.h
	dialog/svg-fonts-dialog.h
	dialog/svg-preview.h
	dialog/swatches.h
	dialog/symbols.h
	dialog/paint-servers.h
	dialog/text-edit.h
	dialog/tile.h
	dialog/tracedialog.h
	dialog/transformation.h
	dialog/undo-history.h
	dialog/xml-tree.h
	dialog/save-template-dialog.h

	knot/knot.h
	knot/knot-enums.h
	knot/knot-holder.h
	knot/knot-holder-entity.h
	knot/knot-ptr.h

	tool/commit-events.h
	tool/control-point-selection.h
	tool/control-point.h
	tool/curve-drag-point.h
	tool/manipulator.h
	tool/modifier-tracker.h
	tool/multi-path-manipulator.h
	tool/node-types.h
	tool/node.h
	tool/path-manipulator.h
	tool/selectable-control-point.h
	tool/shape-record.h
	tool/transform-handle-set.h

	toolbar/arc-toolbar.h
	toolbar/box3d-toolbar.h
	toolbar/calligraphy-toolbar.h
	toolbar/connector-toolbar.h
	toolbar/dropper-toolbar.h
	toolbar/marker-toolbar.h
	toolbar/eraser-toolbar.h
	toolbar/gradient-toolbar.h
	toolbar/lpe-toolbar.h
	toolbar/measure-toolbar.h
	toolbar/mesh-toolbar.h
	toolbar/node-toolbar.h
	toolbar/page-toolbar.h
	toolbar/paintbucket-toolbar.h
	toolbar/pencil-toolbar.h
	toolbar/rect-toolbar.h
	toolbar/select-toolbar.h
	toolbar/booleans-toolbar.h
	toolbar/spiral-toolbar.h
	toolbar/spray-toolbar.h
	toolbar/star-toolbar.h
	toolbar/text-toolbar.h
	toolbar/toolbar.h
	toolbar/tweak-toolbar.h
	toolbar/zoom-toolbar.h

	toolbar/toolbar-constants.h
	toolbar/toolbars.h
	toolbar/command-toolbar.h
	toolbar/tool-toolbar.h
	toolbar/snap-toolbar.h

	tools/arc-tool.h
	tools/box3d-tool.h
	tools/calligraphic-tool.h
	tools/connector-tool.h
	tools/dropper-tool.h
	tools/dynamic-base.h
	tools/eraser-tool.h
	tools/flood-tool.h
	tools/freehand-base.h
	tools/gradient-tool.h
	tools/lpe-tool.h
	tools/measure-tool.h
	tools/mesh-tool.h
	tools/node-tool.h
	tools/object-picker-tool.h
	tools/pages-tool.h
	tools/pen-tool.h
	tools/pencil-tool.h
	tools/rect-tool.h
	tools/marker-tool.h
	tools/select-tool.h
	tools/booleans-builder.h
	tools/booleans-tool.h
	tools/booleans-subitems.h
	tools/shortcuts.h
	tools/spiral-tool.h
	tools/spray-tool.h
	tools/star-tool.h
	tools/text-tool.h
	tools/tool-base.h
	tools/tweak-tool.h
	tools/zoom-tool.h

	widget/iconrenderer.h
	widget/alignment-selector.h
	widget/anchor-selector.h
	widget/attr-widget.h
	widget/canvas.h
	widget/canvas/fragment.h
	widget/canvas/prefs.h
	widget/canvas/stores.h
	widget/canvas/synchronizer.h
	widget/canvas/util.h
	widget/canvas/texture.h
	widget/canvas/texturecache.h
	widget/canvas/graphics.h
	widget/canvas/pixelstreamer.h
	widget/canvas/updaters.h
	widget/canvas/framecheck.h
	widget/canvas/glgraphics.h
	widget/canvas/cairographics.h
	widget/canvas-grid.h
        widget/canvas-notice.h
	widget/completion-popup.h
	widget/color-entry.h
	widget/color-icc-selector.h
	widget/color-notebook.h
	widget/color-palette.h
	widget/color-palette-preview.h
	widget/color-picker.h
	widget/color-preview.h
	widget/color-scales.h
	widget/color-slider.h
	widget/combo-enums.h
	widget/combo-box-entry-tool-item.h
	widget/combo-tool-item.h
	widget/css-name-class-init.h
	widget/custom-tooltip.h
	widget/dash-selector.h
        widget/desktop-widget.h
	widget/entity-entry.h
	widget/entry.h
	widget/events/canvas-event.h
	widget/events/debug.h
	widget/events/enums.h
	widget/export-lists.h
	widget/export-preview.h
	widget/fill-style.h
	widget/filter-effect-chooser.h
	widget/font-button.h
	widget/font-collection-selector.h

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Contributor: Ray Donnelly <mingw.android@gmail.com>
# Contributor: Naveen M K <naveen521kk@gmail.com>

_realname=inkscape
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.4
pkgrel=6
pkgdesc="Vector graphics editor using the SVG file format (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://inkscape.org/"
msys2_repository_url="https://gitlab.com/inkscape/inkscape"
msys2_references=(
  "cpe: cpe:/a:inkscape:inkscape"
)
license=("spdx:GPL-2.0-or-later")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-gettext-tools")
depends=("${MINGW_PACKAGE_PREFIX}-aspell"
         "${MINGW_PACKAGE_PREFIX}-atkmm"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-cairomm"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-gc"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-gdk-pixbuf2"
         "${MINGW_PACKAGE_PREFIX}-gettext-runtime"
         "${MINGW_PACKAGE_PREFIX}-ghostscript"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-graphicsmagick"
         "${MINGW_PACKAGE_PREFIX}-gsl"
         "${MINGW_PACKAGE_PREFIX}-gspell"
         "${MINGW_PACKAGE_PREFIX}-gtk-update-icon-cache"
         "${MINGW_PACKAGE_PREFIX}-gtkmm3"
         "${MINGW_PACKAGE_PREFIX}-gtksourceview4"
         "${MINGW_PACKAGE_PREFIX}-harfbuzz"
         "${MINGW_PACKAGE_PREFIX}-hicolor-icon-theme"
         "${MINGW_PACKAGE_PREFIX}-lcms2"
         "${MINGW_PACKAGE_PREFIX}-lib2geom"
         "${MINGW_PACKAGE_PREFIX}-libcdr"
         "${MINGW_PACKAGE_PREFIX}-libepoxy"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-librevenge"
         "${MINGW_PACKAGE_PREFIX}-libsigc++"
         "${MINGW_PACKAGE_PREFIX}-libsoup"
         "${MINGW_PACKAGE_PREFIX}-libvisio"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-libxslt"
         "${MINGW_PACKAGE_PREFIX}-libwpg"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-pangomm"
         "${MINGW_PACKAGE_PREFIX}-poppler"
         "${MINGW_PACKAGE_PREFIX}-potrace"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-readline"
         "${MINGW_PACKAGE_PREFIX}-scour"
         "${MINGW_PACKAGE_PREFIX}-zlib")
optdepends=(#"${MINGW_PACKAGE_PREFIX}-pstoedit: latex formulas"
            "${MINGW_PACKAGE_PREFIX}-texlive-scheme-medium: latex formulas"
            "${MINGW_PACKAGE_PREFIX}-python-numpy: some extensions"
            "${MINGW_PACKAGE_PREFIX}-python-lxml: some extensions and filters"
            #"${MINGW_PACKAGE_PREFIX}-scour: optimized SVG output"
            #"${MINGW_PACKAGE_PREFIX}-uniconvertor: reading/writing to some proprietary formats"
            )
source=("https://media.inkscape.org/dl/resources/file/${_realname}-${pkgver}.tar.xz"
        "inkscape-poppler-24.10.patch::https://gitlab.com/inkscape/inkscape/-/commit/22304ae8034d067670a9f95022083a75fac92b4c.patch"
        "inkscape-poppler-24.11.patch::https://gitlab.com/inkscape/inkscape/-/commit/0399372ec240d23e0e70548237a541f2b5bf0f34.patch"
        "inkscape-poppler-24.12.patch::https://gitlab.com/inkscape/inkscape/-/commit/819f698dbfc02035b919d2f0853ea116685dfdda.patch"
        "inkscape-poppler-25.02.patch::https://gitlab.com/inkscape/inkscape/-/commit/9754274ea0ee76d9888ec0b306885ecba6926702.patch"
        "inkscape-gobjectptr.patch::https://gitlab.com/inkscape/inkscape/-/commit/eb6dadcf1a5c660167ba43f3606c8e7cc6529787.patch"
        inkscape-1.0.1-unbundle.patch
        inkscape-1.0.1-install-layout.patch
        007-no-console-clang.patch
        008-fix-glib-2-84-build.patch)
sha256sums=('c59a85453b699addebcd51c1dc07684dd96a10c8aec716b19551db50562e13f5'
            'f2ce2d04cfd8b7db046c57cdc2fd4dc8d5946642f7d47b1d8b87ebc2cd6e8ccc'
            'ce742fe3c522508eb0faaa36076e13fca876de3bc42117ace0a1ecebda73d78d'
            '540aac802ece4ab569eaae6fd1ef163cfb0f145eb94eca5e1d47521f56434494'
            '3956a80a968d861b6f6ff060fa507b15cb65f7f9d6ca49f8632fad454436248c'
            '2c2e04d8524fb75e7758ba43742512ad66447ec0b56f28279f4679b96cd1425f'
            '92387251c1740f1a57cde9e587cc673ef1600813617bd2c9db65598c324a24d4'
            '131b2e1190637df0554ef1ee8cf46440689584375c117d057ab47d5871c58128'
            'c49d38b7c1a66e4b40e1b75fb055b730eb863a67a74d899da6d4d6db6baedcec'
            '776c6bae0eb646313f30e1945438f678e19edc2ea5dcd1851ca89cd4d01d2fd9')
noextract=("${_realname}-${pkgver}.tar.xz")

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  # Symlinks only in packaging/macos and src/3rdparty/cairo folders
  tar -xf ${_realname}-${pkgver}.tar.xz || true

  mv "${srcdir}"/${_realname}-${pkgver}_* "${srcdir}"/${_realname}-${pkgver}
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    inkscape-poppler-24.10.patch \
    inkscape-poppler-24.11.patch \
    inkscape-poppler-24.12.patch \
    inkscape-poppler-25.02.patch \
    inkscape-gobjectptr.patch \
    inkscape-1.0.1-unbundle.patch \
    inkscape-1.0.1-install-layout.patch \
    007-no-console-clang.patch \
  
  # https://gitlab.com/inkscape/inkscape/-/issues/5615
  apply_patch_with_msg \
    008-fix-glib-2-84-build.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  local -a extra_config
  if check_option "debug" "y"; then
    extra_config+=(-DCMAKE_BUILD_TYPE=Debug)
  else
    extra_config+=(-DCMAKE_BUILD_TYPE=Release)
  fi

  CFLAGS+=" -Wno-implicit-function-declaration" \
  MSYS=winsymlinks:native \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${extra_config[@]}" \
    -DBUILD_TESTING=OFF \
    -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
    -DCMAKE_AR=${MINGW_PREFIX}/bin/ar \
    -DWITH_IMAGE_MAGICK=OFF \
    -DWITH_INTERNAL_2GEOM=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
}
